c
c	PODPROGRAM ZA G. KVADRATURO (v 4-h tokah)
c
	subroutine INTGAUSKVAD (xz,xk,yz,yk,xizv,yizv,nx,ny,ho,go)
	real xz,xk,yz,yk,xizv,yizv,nx,ny,ho,go,rx,ry,r,zui
	real xi(4) /-0.8611363,-0.33998104,0.33998104,0.8611363/
	real wi(4) /0.34785484,0.65214515,0.65214515,0.34785484/
	ho=0.
	go=0.
	do n=1,4
	    t=0.5*(xi(n))+0.5
		rx=(xz+t*(xk-xz)-xizv)
		ry=(yz+t*(yk-yz)-yizv)
		r=sqrt(rx**2+ry**2)
		ho=ho+(wi(n)/r**2)*(rx*nx+ry*ny)
		zui=log(1/r)
		go=go+wi(n)*zui
		enddo
	return		
	end
c
c	PRESEK
c	
	subroutine SEKANJE(x1,y1,x2,y2,x3,y3,x4,y4,ni,lambda,krat)
	real x1,y1,x2,y2,x3,y3,x4,y4,ni,stevec,lambda
	integer krat,sumkrat
	stevec=(x2-x1)*(y4-y3)-(y2-y1)*(x4-x3)
	IF (stevec.eq.0.) THEN
	    krat=0
	    return
	ENDIF
	lambda=((x3-x1)*(y4-y3)-(y3-y1)*(x4-x3))/stevec
	ni=((x3-x1)*(y2-y1)-(y3-y1)*(x2-x4))/stevec
	IF (lambda.LT.0.OR.lambda.GT.1.) THEN
	   krat=0
	   return
c	   write(*,*) lambda,ni
        ELSEIF(ni.LT.0.OR.ni.GT.1.) THEN
	   krat=0
	   return
	   ELSE
	   krat=1
	ENDIF
	return
	end
c
c	BRANJE PODATKOV
c
	include "ludcmp.for"
	include "lubksb.for"
	real O (300,5),OD (500,5),L(500),Dx(500),Dy(500)
	real IZVx(500,500),IZVy(500,500),deltaY(500),deltaX(500)
	real K1(500),K2(500),skot(500),Kx(500,500),Ky(500,500)
	real ny(500),dny(500),maxX,maxY,minX,minY
	real nx(500),px(500),py(500),dnx(500)
	real rx,ry,ho,go,H(800,800),G(800,800),r
	real b(500),q(500),por,X(500,500),Y(500,500)
	real hitx(500,500),hity(500,500)
	real prvi,drugi,tretji,cetrti
	real desno,levo,gor,dol
	integer i,j,el,d,l2,e,indx(900),notd,sumakrat,krat,vo,num
	integer k,m
	real ni,lambda,Up(500,500),Hnot,Gnot,stevec,MX,MY,VX,VY
	open (1,file='fluidi5.txt')
	open(5,file='Smer.txt')
	open(6,file='Del.txt')
	read (1,*) el,d
	m=1
	do 10, i=1,el
		read (1,*) (O(i,j),j=1,5)
		do 5, n=1,d
			OD(m,1)=O(i,1)+(O(i,3)-O(i,1))*(n-1)/d
			OD(m,2)=O(i,2)+(O(i,4)-O(i,2))*(n-1)/d
			OD(m,3)=OD(m,1)+(O(i,3)-O(i,1))/d
			OD(m,4)=OD(m,2)+(O(i,4)-O(i,2))/d
			OD(m,5)=O(i,5)/d
			m=m+1
5		continue
10	continue	
	do 15, i=1,el*d
15	write(6,*) (OD(i,j),j=1,5)
c	do 20, i=1,m
c20	write (*,*) (OD(i,j),j=1,5)					
c
c	DOLINE ELEMENTOV
c
	do 30, m=1,el*d
		Dx(m)=OD(m,3)-OD(m,1)
		Dy(m)=OD(m,4)-OD(m,2)
		L(m)=sqrt((Dx(m)*Dx(m))+(Dy(m)*Dy(m)))
30	continue	
c	do 40, m=1,el*d
c40	write (*,*) L(m)
c
c	DOLOITEV IZVOROV
c
	do 50, m=1,el*d
		IZVx(m,1)=(OD(m,1)+(OD(m,3)-OD(m,1))/2)
		IZVy(m,2)=(OD(m,2)+(OD(m,4)-OD(m,2))/2)
50	continue
c	do 60, i=1,el*d
c60	write (*,*) IZVx(i,1),IZVy(i,2)
	
c		
c	DOLOITEV NORMAL ELEMENTOV
c
	do 62, i=1,el*d
	  dnx(i)=(OD(i,3)-OD(i,1))
	  dny(i)=(OD(i,4)-OD(i,2))
	  ny(i)=-dnx(i)/sqrt(dnx(i)**2+dny(i)**2)
	  nx(i)=dny(i)/sqrt(dnx(i)**2+dny(i)**2)
62	continue

c	do 80, i=1,el*d
c80	write (*,*) i, L(i),izvx(i,1),izvy(i,2),nx(i),ny(i),od(i,5)	

c	IZRAUN KOEF. MATRIK H IN G	
c
	PI=3.141592654
	do 90, i=1,el*d   
    	   do 85, j=1,el*d
    	   	IF (i.ne.j) THEN
	           call INTGAUSKVAD (OD(j,1),OD(j,3),OD(j,2),OD(j,4),IZVx(i,1),
     *		       		  IZVy(i,2),nx(j),ny(j),ho,go)	
     	         	H(i,j)=(ho)*(-L(j)/(4*PI))
c     	         	write(*,*) L(j)
			G(i,j)=(go)*(L(j)/(4*PI))
		ELSE
			H(i,j)=0.5
			G(i,j)=(log(2/L(i))+1)*L(i)/(2*PI)
		ENDIF
85	    continue
90	continue
c	write(*,*) ' Reitev matrike H'
c	do 100,i=1,el*d
c100	write(*,1) (H(i,j),j=1,el*d)
c	write(*,*) 'Reitev matrike G'
c	do 110,i=1,el*d
c110	   write(*,1)(G(i,j),j=1,el*d)
c1	    format(100F6.2) 
c
c	POTENCIAL NA OGRAJI
c
	do 120, i=1,el*d
           b(i)=0
	     do 115, j=1,el*d
	        b(i)=b(i)+G(i,j)*OD(j,5)	      
115	     continue	        
120	continue	       
	call ludcmp (H,el*d,800,indx,por)
	call lubksb (H,el*d,800,indx,b)
c	write(*,*) 'Reitev vektorja U'
c	do 140,i=1,el*d
c140	write (*,2) b(i)
c2	format (100F15.6)
c
c	DOLOITEV TOK V NOTRANJOSTI OBMOJA
c			
c              x smer
c	write (*,*) 'Podaj tevilo tok notrajosti obmoja!'
c	read (*,*) notd
	notd=22
	MX=OD(1,1)
	VX=OD(1,1)
	do 200, i=2,el*d
	   IF (OD(i,1).gt.VX) VX=OD(i,1)
	   IF (OD(i,1).lt.MX) MX=OD(i,1)
200	continue	   
	ox=mx-(vx-mx)/106
	oxg=vx+(vx-mx)/106
	minX=ox-(oxg-ox)/notd
c 
c	      y smer
c
	MY=OD(1,2)
	VY=OD(1,2)
	do 250, i=2,el*d
	   IF (OD(i,2).gt.VY) VY=OD(i,2)
	   IF (OD(i,2).lt.MY) MY=OD(i,2)   
250	continue   
	oy=my-(vy-my)/106
	oyg=vy+(vy-my)/106
	miny=oy-(oyg-oy)/notd
	
c	write(*,*) MX,MY,VX,VY,minX,minY,notd
	do 350,k=1,notd+1
	   do 300, m=1,notd+1
	      X(k,m)=minX+k*(oxg-ox)/notd
	      Y(k,m)=minY+m*(oyg-oy)/notd
300	   continue   
350     continue
c	write(*,*) x(2,2),x(4,2),y(2,2),y(4,2)
c	write(*,*) minx,miny
c	write(*,*)'Koordinate X(k,m)'
c	do 355,i=1,notd+1
c	    write (*,3) (X(i,j),j=1,notd+1)
c355	continue	 
c	write(*,*)'Koordinate Y(k,m)'   
c	do 360,i=1,notd+1
c	    write(*,3) (Y(i,j),j=1,notd+1)
c360	continue	    
c3	format (100F8.3)
c
c	POTENCIAL V NOTRANJOSTI		
c
	do 500, i=1,notd+1
	   do 400, j=1,notd+1
	     sumkrat=0
	        do 380, k=1,el*d
	   call SEKANJE (OD(k,1),OD(k,2),OD(k,3),OD(k,4),
     *	   X(i,j),Y(i,j),X(i,notd+1),Y(i,notd+1),ni,lambda,krat)
    	        sumkrat=sumkrat+krat      
c    	        write(*,*) i,j,k,krat,sumkrat
380    		continue   	
c
c	INT. V NOTRANJOSTI	
c
c	num=0
	vo=sumkrat/2
	po=sumkrat/2.
c	write(*,*) vo,po
	    IF(po.ne.vo) THEN
	      prvi=0
	      drugi=0
	      tretji=0
	      cetrti=0
	      desno=X(i,j)+0.01
	      levo=X(i,j)-0.01
	      gor=Y(i,J)+0.01
	      dol=Y(i,j)-0.01
                do 381, m=1,el*d	
	      call INTGAUSKVAD (OD(m,1),OD(m,3),OD(m,2),OD(m,4),
     * 			desno,Y(i,j),nx(m),ny(m),ho,go)
    		Hnot=(ho)*(-L(m)/(4*PI))
 		Gnot=(go)*(L(m)/(4*PI))
    	      prvi=prvi+OD(m,5)*Gnot-b(m)*Hnot
    	      call INTGAUSKVAD (OD(m,1),OD(m,3),OD(m,2),OD(m,4),
     *			levo,Y(i,j),nx(m),ny(m),ho,go)
     		Hnot=(ho)*(-L(m)/(4*PI))
     		Gnot=(go)*(L(m)/(4*PI))
     	      drugi=drugi+OD(m,5)*Gnot-b(m)*Hnot
     	      call INTGAUSKVAD (OD(m,1),OD(m,3),OD(m,2),OD(m,4),
     *	      		X(i,j),gor,nx(m),ny(m),ho,go)
     	      	Hnot=(ho)*(-L(m)/(4*PI))
     	      	Gnot=(go)*(L(m)/(4*PI))	
     	      tretji=tretji+OD(m,5)*Gnot-b(m)*Hnot		    
     	      call INTGAUSKVAD (OD(m,1),OD(m,3),OD(m,2),OD(m,4),
     *			X(i,j),dol,nx(m),ny(m),ho,go)
     	        Hnot=(ho)*(-L(m)/(4*PI))
     	        Gnot=(go)*(L(m)/(4*PI))
     	      cetrti=cetrti+OD(m,5)*Gnot-b(m)*Hnot    	        
381    	       continue
		hitx(i,j)=(+prvi-drugi)/0.02
		hity(i,j)=(tretji-cetrti)/0.02
	    ELSE
	        hitx(i,j)=0
	        hity(i,j)=0
	    ENDIF	    
400	  continue		    
500	continue
c	do 515, z=1,notd
c	   do 510, v=1,notd 
c	     U(z,v)=u
c	write(*,*)' Notranji potencial Up(i,j)'
c	do 550,i=1,notd   
c	write(*,6) (Up(i,j),j=1,notd)
c6	format (100F6.2)
c550	continue
c	write(*,*)Up(1,1),Up(2,2),Up(3,3),Up(4,4),Up(5,5)
c
c	IZRAUN HITROSTI
c
c	do 750, k=1,notd-1
c	    do 700,m=1,notd-1
c	       hitx(k,m)=(Up(k,m+1)-Up(k,m-1))/(2*(VX-MX)/notd)
c	       hity(k,m)=(Up(k+1,m)-Up(k-1,m))/(2*(VY-MY)/notd)
c700	    continue
c750     continue
c	write(*,*) 'Hitrost Vx(i,j)'
c	do 800 i=1,notd+1
c800 	write(*,8) (hitx(i,j),j=1,notd+1)		       
c	write(*,*) 'Hitrost Vy(i,j)'
c	do 810 i=1,notd+1
c810	write(*,8) (hity(j,i),j=1,notd+1)
c8	format(100F6.2)

c	VPIS V DATOTEKO
c
	do 900,k=1,notd
		   do 880,m=1,notd
	     write (5,*) X(k,m),Y(k,m),hitx(k,m),hity(k,m)
880	   continue
900     continue	
  	end